/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import domen.Mesto;
import domen.PoslovniPartner;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student
 */
public class DBBroker {
    
    
    Connection konekcija;

    public DBBroker() {
    }
    
    
    public void uspostaviKonekciju() throws SQLException{
        
        try {
            String konekcioniString = "jdbc:mysql://localhost:3306/partnerid4";
            String username = "root";
            String password = "";
            Class.forName("com.mysql.jdbc.Driver");
            konekcija = DriverManager.getConnection(konekcioniString, username, password);
            konekcija.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
            System.out.println("USPESNO POVEZIVANJE!");
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    public void zatvoriKonekciju() throws SQLException{
        if (!konekcija.isClosed()){
            konekcija.close();
        }
    }
    
    public void commitTransakcije() throws SQLException  {
        konekcija.commit();
    }
    
    public void rollbackTransakcije() throws SQLException {
        konekcija.rollback();
    }
    
    public List<Mesto> vratiSvaMesta() throws SQLException{
        
        List listaMesta = new ArrayList();
        
        String upit = "SELECT * FROM MESTO";
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsMesto =  naredba.executeQuery(upit);
        Mesto m;
        
        while (rsMesto.next()){
            
            m = new Mesto();
            m.setPtt(rsMesto.getInt("ptt"));
            m.setNaziv(rsMesto.getString("naziv"));
            
            listaMesta.add(m);
        }
        
        
        return listaMesta;
    }
    
    
    public void sacuvajPartnera(PoslovniPartner partner) throws SQLException{
        
        //String upit = "INSERT INTO partner VALUES ("+partner.getPartnerID()+",'"+partner.getNaziv()+"','"+partner.getPib()+")";
        
        String upit = "INSERT INTO partner VALUES (?,?,?,?,?,?,?)";
        
        PreparedStatement pNaredba = konekcija.prepareStatement(upit);
        
        pNaredba.setInt(1, partner.getPartnerID());
        pNaredba.setString(2, partner.getNaziv());
        pNaredba.setString(3, partner.getPib());
        pNaredba.setString(4, partner.getMaticniBroj());
        pNaredba.setString(5, partner.getUlica());
        pNaredba.setString(6, partner.getBroj());
        pNaredba.setInt(7, partner.getMesto().getPtt());
        
        pNaredba.executeUpdate();
    }
    
    public List<PoslovniPartner> vratiPartnere() {
        String sql = "SELECT * FROM Partner p INNER JOIN Mesto m ON (p.mesto=m.ptt)";
        // TODO Uraditi za domaci.
        return null;
    }
    
    
    
    public static void main(String[] args) {
        try {
            DBBroker dbbr = new DBBroker();
            dbbr.uspostaviKonekciju();
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
                
    }
    
}
