/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package poslovnalogika;

import dbbr.DBBroker;
import domen.Mesto;
import domen.PoslovniPartner;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kolekcija.KolekcijaMesta;
import kolekcija.KolekcijaPoslovniPartnera;

/**
 *
 * @author student
 */
public class Kontroler {

    private KolekcijaMesta km;
    private KolekcijaPoslovniPartnera kp;

    private DBBroker dbbr;
    private static Kontroler instance;

    private Kontroler() {
        km = new KolekcijaMesta();
        kp = new KolekcijaPoslovniPartnera();
        dbbr = new DBBroker();
    }

    public static Kontroler getInstance() {
        if (instance == null) {
            instance = new Kontroler();
        }
        return instance;
    }

    public void sacuvajMesto(Mesto m) {
        km.sacuvajMesto(m);
    }

    public List<Mesto> vratiMesta() throws SQLException {

        // DODATI FINALLY BLOK U KOME CE SE ZATVORITI KONEKCIJA!!!
        //return km.vratiMesta();
        dbbr.uspostaviKonekciju();
        return dbbr.vratiSvaMesta();

    }

    public void sacuvajPartnera(PoslovniPartner pp) throws SQLException {
        // DODATI FINALLY BLOK U KOME CE SE ZATVORITI KONEKCIJA!!!
        //kp.sacuvajPartnera(pp);
        dbbr.uspostaviKonekciju();
        dbbr.sacuvajPartnera(pp);
    }

    public List<PoslovniPartner> vratiPartnere() {
        return kp.vratiPartnere();
    }

    public void sacuvajPartnere(List<PoslovniPartner> lp) throws Exception {
        try {
            dbbr.uspostaviKonekciju();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Neuspesno uspostavljanje konekcije!", ex);
        }
        try {
            for (PoslovniPartner pp : lp) {
                dbbr.sacuvajPartnera(pp);
                System.out.println("Sacuvan parter sa ID: " + pp.getPartnerID());
            }
            dbbr.commitTransakcije();
        } catch (SQLException ex) {
            ex.printStackTrace();
            dbbr.rollbackTransakcije();
            throw new Exception("Neuspesno cuvanje partnera!", ex);
        }
        try {
            dbbr.zatvoriKonekciju();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Neuspesno zatvaranje konekcije!", ex);
        }
    }

}
